<?php
/*------------------------------------------------------------------------

# wall.php - YO Pixel Controller

# ------------------------------------------------------------------------

# author    YOphp Site

# copyright Copyright (C) 2010 yophp.com. All Rights Reserved.

# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL

# Websites: http://www.yophp.com

# Technical Support:  Forum - http://forum.yophp.com

-------------------------------------------------------------------------*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

class YO_PixelModelWall extends JModel {

	var $_data;
	var $_wall;
	var $_ads;

	public function __construct() {
		parent::__construct();

		global $mainframe;
		$app	=	JFactory::getApplication();
		//FILTER ORDER
		$filter_order_Dir	= JRequest::getVar( 'filter_order_Dir',	'ASC' );
		$this->setState('filter_order_Dir', $filter_order_Dir);

		$filter_order		= JRequest::getVar( 'filter_order', 'id' );
		$this->setState('filter_order', $filter_order);

		$array = JRequest::getVar('cid',  null, '', 'array');
		$this->setId((int)$array[0]);

		$limit		= $app->getUserStateFromRequest( 'limit', 'limit', $app->getCfg('limit'), 'int' );
		$limitstart	= $app->getUserStateFromRequest( 'limitstart', 'limitstart', 0, 'int' );

		$limitstart		=	($limit	!=0? floor($limitstart / $limit)*$limit : 0);

		$this->setState('limitstart',	$limitstart);
		$this->setState('limit'		,		$limit);
	}

	function setId( $id ) {
		$this->_id = $id;
		$this->_data = null;
	}

	FUNCTION getOrdering () {
		$list['filter_order_Dir']	=	$this->getState('filter_order_Dir');
		$list['filter_order']		=	$this->getState('filter_order');

		RETURN $list;
	}

	//load wall is existed.
	function getWallData() {

		if(empty($this->_wall)) {
			$query = 'SELECT * FROM #__yo_pixel ORDER BY '.$this->getState('filter_order').' '.$this->getState('filter_order_Dir');
			$this->_wall = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}
		return $this->_wall;

	}

	function &getWall() {

		if ( empty( $this->_data ) ) {
			if (JRequest::getVar('task', '') == 'add' ){
				$this->_id = 0;
			}
			if ( JRequest::getInt('id', 0) != 0 ) {
				$this->_id = JRequest::getInt('id');
			}
			$query = ' SELECT * FROM #__yo_pixel WHERE id = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$this->_data 				= 	new stdClass();
			$this->_data->id 			= 	0;
			$this->_data->name 			= 	null;
			$this->_data->description 	= 	null;
			$this->_data->ssubmit 		= 	1;
			$this->_data->cols			=	null;
			$this->_data->rows			=	null;
			$this->_data->size			=	null;
		}
		return $this->_data;
	}

	//break page.
	function PaginationOfWall( ) {

		if(empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$total		=	$this->_getListCount('SELECT id FROM #__yo_pixel');
			$this->_pagination	=	new JPagination($total, $this->getState('limitstart'), $this->getState('limit'));
		}
		return $this->_pagination;
	}

	function PaginationOfAdsCells( $wall_id ) {

		if(empty($this->_pagination2)) {
			jimport('joomla.html.pagination');
			$total		=	$this->_getListCount('SELECT id FROM #__yo_ads WHERE wall_id='.$wall_id );
			$this->_pagination2	=	new JPagination($total, $this->getState('limitstart'), $this->getState('limit'));
		}
		return $this->_pagination2;
	}

	//check valid input wall
	function WallValid() {
		$error = '';
		if ( JRequest::getInt('id', 0) == 0 ) {
			$db = JFactory::getDBO();
			$query = 'SELECT name FROM #__yo_pixel';
			$db->setQuery($query);
			$list_names = $db->loadObjectList();
			foreach ($list_names as $name ) {
				if ( strtolower(JRequest::getString('name', '')) == strtolower($name->name) ) {
					$error .= JText::_('NAME_EXIST').'<br />';
				}
			}
		}
		if ( JRequest::getString('name', '') == '' ) {
			$error .= JText::_('NAME_EMPTY').'<br />';
		}
		if ( !is_numeric( JRequest::getVar('cols' )) & isset($_REQUEST['cols']) ) {
			$error .= JText::_('VALID_COLS').'<br />' ;
		} else if ( JRequest::getInt('cols', 0 ) == 0 & isset($_REQUEST['cols']) ) {
			$error .= JText::_('COLS_WALL_ZERO').'<br />' ;
		}
		if ( !is_numeric( JRequest::getVar('rows'))  & isset($_REQUEST['rows']) ) {
			$error .= JText::_('VALID_ROWS').'<br />' ;
		} else if ( JRequest::getInt('rows', 0) == 0 & isset($_REQUEST['rows']) ){
			$error .= JText::_('ROWS_WALL_ZERO').'<br />';
		}
		if ( !is_numeric( JRequest::getVar('size')) ) {
			$error.=  JText::_('VALID_SIZE').'<br />' ;
		} else if ( JRequest::getInt('size', 0) == 0 ) {
			$error.=  JText::_('SIZE_WALL_ZERO').'<br />' ;
		}
		if ( $error != '') {
			echo '<font color="red" >'.$error.'</font>';
			return false;
		}
		return true;
	}

	function AdsValidation() {
		$error = '';
		if ( JRequest::getString('name', '') == '' ) {
			$error .= JText::_('NAME_ADS_EMPTY').'<br />';
		}
		if ( JRequest::getString('info', '') == '') {
			$error .= JText::_('INFO_ADS_EMPTY').'<br />';
		}
		if ( JRequest::getstring('url', '') == '' ) {
			$error .= JText::_('URL_ADS_EMPTY').'<br />';
		}
		if ( $error != '' ) {
			echo '<font color="red">'.$error.'</font>';
			return false;
		}

		return true;
	}

	function store() {

		$row =& $this->getTable('wall');
		$data = JRequest::get( 'post' );

		// Bind the form fields to the profile table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Make sure the prifile record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			return false;
		}
		return true;
	}

	function delete() {
		$cids = JRequest::getVar( 'cid', array(0), 'POST', 'array' );
		$row =& $this->getTable('wall');

		$db = JFactory::getDBO();
		if (count( $cids )) {
			foreach($cids as $cid) {
				if (!$row->delete( $cid )) {
					$this->setError( $row->getErrorMsg() );
					RETURN false;
				}
				//get all Ads in the wall above
				$query = 'SELECT id FROM #__yo_ads WHERE wall_id='.$cid;
				$db->setQuery($query);
				if ( count( $db->loadObjectList() ) != 0 ) {
					foreach ($db->loadObjectList() as $listAds ) {
						//delete all cells appropriate with each Ads
						$query = 'DELETE FROM #__yo_ads_cells WHERE ads_id='.$listAds->id;
						$db->setQuery($query);
						$db->query();
					}
				}
				//delete all Ads in the wall above
				$query = 'DELETE FROM #__yo_ads WHERE wall_id='.$cid;
				$db->setQuery($query);
				$db->query();
			}
		}
		RETURN true;
	}

	function loadCells ( $wall_id ) {
		$query = 'SELECT a.cell_id, b.status, a.ads_id FROM #__yo_ads_cells AS a
					INNER JOIN #__yo_ads AS b ON b.id=a.ads_id
				  WHERE b.wall_id='.$wall_id;
		$db = JFactory::getDBO();

		$db->setQuery($query);
		return $db->loadObjectList();
	}

	function wallParams( $wall_id ) {
		$db = JFactory::getDBO();
		$query = 'SELECT * FROM #__yo_pixel WHERE id='.$wall_id;
		$db->setQuery($query);

		return $db->loadObject();
	}

	function getListWall( $wall_id, $action ) {

		$db = JFactory::getDBO();
		$sql = 'SELECT * FROM #__yo_pixel';

		$db->setQuery($sql);

		$catlist[]         = JHTML::_('select.option',  '0', JText::_( '- Select wall name -' ), 'id', 'name' );

		$catlist         = array_merge( $catlist, $db->loadObjectList() );
		$lists['wall']      = JHTML::_('select.genericlist', $catlist, 'wall_id', $action, 'id', 'name', $wall_id);

		RETURN $lists;
	}

	function adsPending( $wall_id ) {
		$db = JFactory::getDBO();
		$query = 'SELECT id FROM #__yo_ads WHERE status=\'pending\' wall_id='.$wall_id;
		$db->setQuery($query);

		return $db->loadObjectList();
	}

	/**
	 * Get all Ads approriate with each wall
	 *
	 * @param $wall_id Id's wall
	 * @return List Ads in wall
	 */
	function AdsOfWall ( $wall_id ) {
		if(empty($this->_ads)) {
			$query = 'SELECT * FROM #__yo_ads WHERE wall_id='.$wall_id.' ORDER BY '.$this->getState('filter_order').' '.$this->getState('filter_order_Dir');
			$this->_ads = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}
		return $this->_ads;
	}

	/**
	 * Load all cells approriate with Ads
	 *
	 * @param $ads_id id's ads
	 * @return List cells in Ads owner
	 */
	function CellsOfAds ( $ads_id ) {
		$db = JFactory::getDBO();
		$query = 'SELECT * FROM #__yo_ads_cells WHERE ads_id='.$ads_id;
		$db->setQuery($query);

		return $db->loadObjectList();
	}

	function deleteAds() {
		$db = JFactory::getDBO();
		//get column number of wall

		$cids = JRequest::getVar( 'cid', null, 'POST', 'array' );
		$row =& $this->getTable('ads');
		if ( count($cids) != 0 ) {
			$db = JFactory::getDBO();
			if (count( $cids )) {
				foreach($cids as $cid) {
					if (!$row->delete( $cid )) {
						$this->setError( $row->getErrorMsg() );
						RETURN false;
					}
					$this->deleteAdsData($cid, JRequest::getInt('wall_id', 0));
				}
			}
		} else {
			if (!$row->delete( JRequest::getInt('ads_id', 0) )) {
				$this->setError( $row->getErrorMsg() );
				RETURN false;
			}
			$this->deleteAdsData(JRequest::getInt('ads_id', 0), JRequest::getInt('wall_id', 0));
		}
		echo 'Delete successful!';
		RETURN true;
	}

	function deleteAdsData( $ads_id, $wall_id ) {
		$db = JFactory::getDBO();
		$query = 'SELECT cols FROM #__yo_pixel WHERE id='.$wall_id;
		$db->setQuery($query);
		$cols = $db->loadObject();
		$query = 'SELECT cell_id FROM #__yo_ads_cells WHERE ads_id='.$ads_id;
		$db->setQuery($query);
		$arr_cells = $db->loadObjectList();

		foreach ($arr_cells as $value) {
			$filename = $this->convertIntToCoordinate( $value->cell_id, $cols->cols );
			$path_file = JPATH_COMPONENT_SITE.DS.'imgs'.DS.'wall_'.$wall_id.DS.$filename[1].'.'.$filename[0].'.jpg';
			if (JFile::exists($path_file) ) {
				JFile::delete( $path_file );
			}
		}
		$query = 'DELETE FROM #__yo_ads_cells WHERE ads_id='.$ads_id;
		$db->setQuery($query);
		$db->query();
	}

	function CellsOfMutiAds() {
		$adsId = JRequest::getVar('cid', null, '', 'array');
		$arr_cells = array();
		if ( count($adsId) != 0 ) {
			foreach ($adsId as $id ) {
				$cells = $this->CellsOfAds( $id );
				foreach ( $cells as $cell ) {
					array_push( $arr_cells, $cell->cell_id );
				}
			}
		}

		return $arr_cells;
	}

	function published( $status ) {

		$cid	=	JRequest::getVar('cid', null, 'Array' );
		$cids	=	implode(',', $cid);
		$db		=	JFactory::getDBO();
		$query	=	'UPDATE #__yo_ads SET status=\''.$status.'\' WHERE id IN ('.$cids.')';
		$db->setQuery($query);
		$db->query();

		return true;
	}

	function getAds ( $ads_id ) {
		$db = JFactory::getDBO();
		$query = 'SELECT * FROM #__yo_ads WHERE id='.$ads_id;
		$db->setQuery($query);

		return $db->loadObject();
	}

	function storeAds() {
		$session = JFactory::getSession();
		require_once(dirname(__FILE__).DS.'..'.DS.'helper'.DS.'draw_img.php');
		//get cells of Ads
		$cells = $this->CellsOfAdsToArr( JRequest::getInt( 'ads_id', 0 ), JRequest::getInt('wall_id', 0) );
		$arr_xy = $this->getsize( JRequest::getInt('wall_id', 0), $cells);
		//get size of wall
		$dimension = $this->wallParams( JRequest::getInt('wall_id', 0));
		$img = $session->get('tmp_img');
		if ($img != '' || $img != null)
		{
			$draw_img = new drawImg();
			if ( JFile::exists(JPATH_COMPONENT_SITE.DS.DS.'imgs'.DS.$img )) {
				//draw border image
				$draw_img->drawBorder(JPATH_COMPONENT_SITE.DS.'imgs'.DS.$img, $img );
				//split this image to parts image is smaller.
				$draw_img->cut_Img(JPATH_COMPONENT_SITE.DS.'imgs'.DS.$img, $arr_xy[0]/$dimension->size, $arr_xy[1]/$dimension->size, $dimension->size, $dimension->cols, $cells );
			}
			//save image
			$this->imageAction( $img );
		}
		//update info
		$db = JFactory::getDBO();
		$query = 'UPDATE #__yo_ads SET name=\''.JRequest::getString('name').'\',
					 url=\''.JRequest::getString('url').'\', info=\''.JRequest::getString('info').'\'
				  WHERE id='.JRequest::getInt('ads_id');
		$db->setQuery($query);
		$db->query();

		return true;
	}

	//delete tmp file
	function imageAction( $img ) {
		$user = JFactory::getUser();
		//get id of wall
		$wall_id = JRequest::getInt( 'wall_id', 0 );

		//move file to new folder
		if ( !JFolder::exists(JPATH_COMPONENT_SITE.DS.'imgs'.DS.'wall_'.$wall_id )) {
			JFolder::create(JPATH_COMPONENT_SITE.DS.'imgs'.DS.'wall_'.$wall_id );
		}
		$files = JFolder::files(JPATH_COMPONENT_SITE.DS.'imgs'.DS.'tmp_'.$user->username, '.', false, true, array());

		foreach ($files as $file) {
			$file_name = split(JPATH_COMPONENT_SITE.DS.'imgs'.DS.'tmp_'.$user->username.DS, $file);
			JFile::copy($file, JPATH_COMPONENT_SITE.DS.'imgs'.DS.'wall_'.$wall_id.DS.$file_name[1]);
		}
		//delete tmp folder
		$folder_path = JPATH_COMPONENT_SITE.DS.'imgs'.DS.'tmp_'.$user->username;
		if ( JFolder::exists($folder_path)) {
			JFolder::delete($folder_path);
		}
		$this->deleteSession();
	}

	function deleteSession() {
		$session = JFactory::getSession();
		$file_path = JPATH_COMPONENT_SITE.DS.'imgs'.DS.$session->get('tmp_img');
		if ( JFile::exists( $file_path ) ) {
			JFile::delete( $file_path );
		}
		$session->set('tmp_img', '');
	}

	/**
	 * get new size of image
	 *
	 * @return array: width, height
	 */
	function getsize($wall_id, $cells ) {

		$arr_pos	=	array();
		//get size of wall
		$db = JFactory::getDBO();
		$query = 'SELECT * FROM #__yo_pixel WHERE id='.$wall_id;
		$db->setQuery($query);
		$dimension = $db->loadObject();

		$min_x = $min_y = 1000000000;
		$max_x = $max_y = 0;

		$cells = preg_split('/,/', $cells);

		for ($i=0; $i<count($cells); $i++ ) {
			echo $cells[$i].'<br>';
			$arr_cell = $this->convertIntToCoordinate( $cells[$i], $dimension->cols);
			$cells[$i] = $arr_cell[1].'.'.$arr_cell[0];
		}
		foreach ($cells as $cell){

			$arr_xy = preg_split('/\./', $cell);
			if ($arr_xy[0] < $min_x) {
				$min_x = intval($arr_xy[0]);
			}
			if ($arr_xy[0] > $max_x) {
				$max_x = intval($arr_xy[0]);
			}

			if ($arr_xy[1] < $min_y) {
				$min_y = intval($arr_xy[1]);
			}
			if ($arr_xy[1] > $max_y) {
				$max_y = intval($arr_xy[1]);
			}
		}

		$arr_pos[0] = ($max_x - $min_x + 1)*$dimension->size;//return number of column
		$arr_pos[1] = ($max_y - $min_y + 1)*$dimension->size;//return number of row

		return $arr_pos;
	}
	//valid type of image user can posted.
	function imgType() {

		$session = JFactory::getSession();

		$wall_id = JRequest::getInt('wall_id', 0);
		$arr_cell = $this->CellsOfAdsToArr( JRequest::getInt( 'ads_id', 0 ), $wall_id );
		$arr_xy = $this->getsize( $wall_id, $arr_cell );

		require_once(dirname(__FILE__).DS.'..'.DS.'helper'.DS.'cls_iresizer.php');

		if ( $_FILES['upload_img']['type'] == 'image/jpeg' || $_FILES['upload_img']['type'] == 'image/png'
		|| $_FILES['upload_img']['type'] == 'image/pjpeg' )
		{
			$files = JFolder::files(JPATH_COMPONENT_SITE.DS.'imgs', '.', false, true, array());
			for ( $i=0; $i < count($files); $i++ ) {
				if ( $files[$i] == JPATH_COMPONENT_SITE.DS.'imgs'.DS.$session->get('tmp_img') ) {
					JFile::delete($files[$i]);
				}
			}

			$user	=	JFactory::getUser();
			$img_url = JPATH_COMPONENT_SITE.DS.'imgs'.DS.$user->username.'_'.$_FILES['upload_img']['name'];
			//save file to server
			JFile::upload($_FILES['upload_img']['tmp_name'], $img_url);
			//set session to image name
			$session->set('tmp_img', $user->username.'_'.$_FILES['upload_img']['name']);
			echo $session->get('tmp_img');
			//resize image
			$imageResizer = new ImageResizer();
			$imageResizer->loadImage($img_url);
			$imageResizer->resize($arr_xy[1], $arr_xy[0]);
			$resize_img = $imageResizer->getResult();

			imagepng($resize_img, $img_url);
			return true;
		}

		return false;
	}

	//merge element cells
	/**
	 * get cells with id's ads
	 * @return list cells
	 */
	function CellsOfAdsToArr( $ads_id , $wall_id ) {

		$user = JFactory::getUser();
		$db = JFactory::getDBO();
		$query = 'SELECT cell_id FROM #__yo_ads_cells AS a INNER JOIN #__yo_ads AS b
					ON a.ads_id=b.id
				  WHERE b.user_id='.$user->id.' AND b.wall_id='.$wall_id.' AND a.ads_id='.$ads_id;
		$db->setQuery($query);

		$arr_cell = '';
		$cells = $db->loadObjectList();
		for ( $i=0; $i < count( $cells ); $i++ ) {
			if ( $i == count( $cells ) - 1 ) {
				$arr_cell .= $cells[$i]->cell_id;
			} else {
				$arr_cell .= $cells[$i]->cell_id.',';
			}
		}
		return $arr_cell;
	}
	/**
	 * convert int value to co-ordinate
	 *
	 * @param $value: value will be converted
	 * @param $cols: columns number of wall
	 * @return array
	 */
	function convertIntToCoordinate( $value , $cols ) {
		$cells = array();
		$cells[0] = $value % $cols;
		$cells[1] = floor( $value/$cols );
		return $cells;
	}

	function ListAdsPublished( $wall_id ) {
		$db = JFactory::getDBO();
		$query = 'SELECT * FROM #__yo_ads WHERE wall_id='.$wall_id;
		$db->setQuery($query);

		return $db->loadObject();
	}

	function ssubmit() {
		$db = JFactory::getDBO();

		$cids = JRequest::getVar( 'cid', null, 'post', 'array' );

		foreach ($cids as $cid) {
			$query = 'UPDATE #__yo_pixel SET ssubmit=1 WHERE id='.$db->Quote($cid);
			$db->setQuery($query);
			if (!$db->query())
			return false;
		}

		return true;
	}

	function hsubmit() {
		$db = JFactory::getDBO();

		$cids = JRequest::getVar( 'cid', null, 'post', 'array' );

		foreach ($cids as $cid) {
			$query = 'UPDATE #__yo_pixel SET ssubmit=0 WHERE id='.$db->Quote($cid);
			$db->setQuery($query);
			if (!$db->query())
			return false;
		}

		return true;
	}

}
?>