<?php
/*------------------------------------------------------------------------

# wall.php - YO Pixel Controller

# ------------------------------------------------------------------------

# author    YOphp Site

# copyright Copyright (C) 2010 yophp.com. All Rights Reserved.

# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL

# Websites: http://www.yophp.com

# Technical Support:  Forum - http://forum.yophp.com

-------------------------------------------------------------------------*/
defined('_JEXEC') or die();

jimport('joomla.application.component.controller');
JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');

class YO_PixelControllerWall extends YO_PixelController {

	function __construct() {
		parent::__construct();

		$this->registerTask( 'add', 'edit');
		$this->registerTask( 'delete', 'remove' );
		$this->registerTask( 'save', 'store' );
		$this->registerTask( 'saveAds', 'storeAds' );
		$this->registerTask('addCoupon','editCoupon');;
		$this->registerTask( 'detail', 'detail');
		$this->registerTask( 'removeAds', 'removeAds');
		$this->registerTask('removecustomer','removecustomer');
		$this->registerTask( 'viewWall', 'detail');
		$this->registerTask( 'default', 'detail');
		$this->registerTask('paypal','detailpaypal');
		$this->registerTask('config','config');
		//edit adsf
		$this->registerTask('editAds', 'editAds');
		$this->registerTask('imgType', 'imgType');
		$this->registerTask('editpaypalconfig','editpaypalconfig');
		$this->registerTask('saveConfig','storeConfig');
		$this->registerTask('saveConfiguration','storeConfiguration');
		$this->registerTask('editConfiguration','editConfiguration');
		$this->registerTask('saveCoupon','storeCoupon');

		JSubMenuHelper::addEntry('Wall', 'index.php?option=com_yo_pixel', false);
		JSubMenuHelper::addEntry('Advertising', 'index.php?option=com_yo_pixel&amp;controller=wall&amp;task=detail', false);
		JSubMenuHelper::addEntry('Paypal Config', 'index.php?option=com_yo_pixel&amp;controller=wall&amp;task=detailpaypalconfig', false);
		JSubMenuHelper::addEntry('Configuration', 'index.php?option=com_yo_pixel&amp;controller=wall&amp;task=detailconfigurations', false);
		JSubMenuHelper::addEntry('Coupon Manager', 'index.php?option=com_yo_pixel&amp;controller=wall&amp;task=coupon', false);
	}

	//edit method
	function edit() {
		JRequest::setVar( 'hidemainmenu', 1 );
		JToolBarHelper::save('save');
		//		JToolBarHelper::customX('save', 'save_custom', '', 'Save', false);
		JToolBarHelper::cancel('cancel');
		//		JToolBarHelper::customX('cancel', 'cancel_custom', '', 'Cancel', false);

		$arr = JRequest::getVar('cid', null, '', 'array');
		if(count($arr) != 0 ) {
			$id = $arr[0];
		} else {
			$id = JRequest::getInt('id', 0);
		}
		$isNew = ($id < 1);
		if( $isNew ) {
			JToolBarHelper::title('New Wall','home_custom.png');
		} else {
			JToolBarHelper::title('Edit Wall','home_custom.png');
		}

		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();

		$vName		= JRequest::getCmd('view', 'wall');

		$vLayout 	= JRequest::getCmd('layout', 'new');

		$mName		= 'wall';
		// Get/Create the view
		$view = &$this->getView( $vName, $vType);
		// Get/Create the model
		if ($model = &$this->getModel($mName)) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}

		// Set the layout
		$view->setLayout($vLayout);

		// Display the view
		$view->display();
	}


	function ssubmit() {
		$model = $this->getModel('wall');
		if ( $model->ssubmit() ) {
			$msg = 'Show Submit Complete!';
		} else {
			$msg = 'Show Submit Error!'	;
		}

		$this->setRedirect('index.php?option=com_yo_pixel', $msg);
	}

	function hsubmit() {
		$model = $this->getModel('wall');
		if ( $model->hsubmit() ) {
			$msg = 'Hide Submit Complete!';
		} else {
			$msg = 'Hide Submit Error!'	;
		}

		$this->setRedirect('index.php?option=com_yo_pixel', $msg);
	}

	function store() {
		$model = $this->getModel('wall');
		if ( $model->WallValid() ) {
			if ( $model->store() ) {
				$msg = 'Save successful!';
			} else {
				$msg = 'Save Error!'	;
			}
			$this->setRedirect('index.php?option=com_yo_pixel', $msg);
		} else {
			$this->edit();
		}
		return ;
	}

	function remove () {
		$model = $this->getModel('wall');
		if ( $model->delete() ) {
			$msg = 'Delete successful!';
		} else {
			$msg = 'Delete Error!'	;
		}

		$this->setRedirect('index.php?option=com_yo_pixel', $msg);
	}

	function detail() {
		JToolBarHelper::title('Image Manager','home_custom.png');
		JToolBarHelper::publish();
		JToolBarHelper::unpublish();
		JToolBarHelper::custom('viewWall', 'apply.png','', 'View');
		JToolBarHelper::custom('default', 'reload.png', '', 'Default', false);
		JToolBarHelper::editList('editAds', 'Edit');
		JToolBarHelper::deleteList('Are you sure?', 'removeAds');

		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();

		$vName		= JRequest::getCmd('view', 'wall');

		$vLayout 	= JRequest::getCmd('layout', 'detail');

		$mName		= 'wall';
		// Get/Create the view
		$view = &$this->getView( $vName, $vType);
		// Get/Create the model
		if ($model = &$this->getModel($mName)) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}

		// Set the layout
		$view->setLayout($vLayout);

		// Display the view
		$view->display();


		//mamager paypal
	}




	//Paypal config

	function detailpaypalconfig() {
		JToolBarHelper::cancel();
		JToolBarHelper::title('Paypal Config','home_custom.png');
		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();

		$vName		= JRequest::getCmd('view', 'paypalconfig');

		$vLayout 	= JRequest::getCmd('layout', 'form');

		$mName		= 'paypalconfigs';
		// Get/Create the view
		$view = &$this->getView( $vName, $vType);
		// Get/Create the model
		if ($model = &$this->getModel($mName)) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}

		// Set the layout
		$view->setLayout($vLayout);

		// Display the view
		$view->display();
	}
	function detailconfigurations() {
		//JRequest::setVar( 'hidemainmenu', 1 );
		JToolBarHelper::save('saveConfiguration');
		JToolBarHelper::cancel();
		JToolBarHelper::title('Configutation','home_custom.png');
		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();

		$vName		= JRequest::getCmd('view', 'configuration');

		$vLayout 	= JRequest::getCmd('layout', 'form');

		$mName		= 'configuration';
		// Get/Create the view
		$view = &$this->getView( $vName, $vType);
		// Get/Create the model
		if ($model = &$this->getModel($mName)) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}

		// Set the layout
		$view->setLayout($vLayout);

		// Display the view
		$view->display();
	}
	//Coupon
	function coupon() {
		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();

		$vName		= JRequest::getCmd('view', 'coupons');

		$vLayout 	= JRequest::getCmd('layout', 'default');

		$mName		= 'coupons';
		// Get/Create the view
		$view = &$this->getView( $vName, $vType);
		// Get/Create the model
		if ($model = &$this->getModel($mName)) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}

		// Set the layout
		$view->setLayout($vLayout);

		// Display the view
		$view->display();
	}

	function removeAds() {
		$model = $this->getModel('wall');
		if ( $model->deleteAds() ) {
			$msg = 'Delete successful!';
		} else {
			$msg = JText::_('DELETE_ADS_ERROR');
		}
		$this->setRedirect('index.php?option=com_yo_pixel&controller=wall&task=detail&wall_id='.JRequest::getInt('wall_id', 0), $msg);
	}



	function publish() {
		if ( count(JRequest::getVar('cid', null, '', 'array'), 0) == 0 )
		{
			$msg = JText::_('ITEM_NOT_FOUND');
			return $this->setRedirect('index.php?option=com_yo_pixel&controller=wall&task=detail&wall_id='.JRequest::getInt('wall_id', 0), $msg );
		}
		$model = $this->getModel('wall');
		if ( $model->published( 'published') ) {
			$msg = JText::_('PUSLISHED_SUCCESS');
		} else {
			$msg = JText::_('PULISHED_ERROR');
		}
		$this->setRedirect('index.php?option=com_yo_pixel&controller=wall&task=detail&wall_id='.JRequest::getInt('wall_id', 0), $msg );
	}

	function unpublish() {
		if ( count(JRequest::getVar('cid', null, '', 'array'), 0) == 0 )
		{
			$msg = JText::_('ITEM_NOT_FOUND');
			return $this->setRedirect('index.php?option=com_yo_pixel&controller=wall&task=detail&wall_id='.JRequest::getInt('wall_id', 0), $msg );
		}
		$model = $this->getModel('wall');
		if ( $model->published( 'unpublished') ) {
			$msg = JText::_('UNPUBLISHED_SUCCESS');
		} else {
			$msg = JText::_('PUBLISHED_ERROR');
		}
		$this->setRedirect('index.php?option=com_yo_pixel&controller=wall&task=detail&wall_id='.JRequest::getInt('wall_id', 0), $msg );
	}

	function editAds() {
		JRequest::setVar( 'hidemainmenu', 1 );
		JToolBarHelper::customX('removeAds', 'trash_custom.png', '', 'Delete this Ads', false);
		JToolBarHelper::save('saveAds');
		JToolBarHelper::cancel('cancel');
		//		JToolBarHelper::customX('cancel', 'cancel_custom', '', 'Cancel', false);

		$arr = JRequest::getVar('cid', 0, '', 'array');
		$isNew = ($arr[0] < 1);
		if( $isNew ) {
			JToolBarHelper::title('New Ads','home_custom.png');
		} else {
			JToolBarHelper::title('Edit Ads','home_custom.png');
		}
		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();
		$vName		= JRequest::getCmd('view', 'ads');
		$vLayout 	= JRequest::getCmd('layout', 'ads');
		$mName		= 'wall';
		// Get/Create the view
		$view = &$this->getView( $vName, $vType);
		// Get/Create the model
		if ($model = &$this->getModel($mName)) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}
		// Set the layout
		$view->setLayout($vLayout);
		// Display the view
		$view->display();
	}

	function editConfiguration() {

		JRequest::setVar( 'hidemainmenu', 1 );
		JToolBarHelper::save('saveConfiguration');
		JToolBarHelper::cancel('canceleditconfiguration','Cancel');
		$arr = JRequest::getVar('cid', 0, '', 'array');
		$isNew = ($arr[0] < 1);

		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();
		$vName		= JRequest::getCmd('view', 'configuration');
		$vLayout 	= JRequest::getCmd('layout', 'form');
		$mName		= 'configuration';
		// Get/Create the view
		$view = &$this->getView( $vName, $vType);
		// Get/Create the model
		if ($model = &$this->getModel($mName)) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}
		// Set the layout
		$view->setLayout($vLayout);
		// Display the view
		$view->display();
	}

	//	function newCoupon(){
	//
	//	}

	function editCoupon() {
		JRequest::setVar( 'hidemainmenu', 1 );
		$arr = JRequest::getVar('cid', 0, '', 'array');
		$isNew = ($arr[0] < 1);

		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();
		$vName		= JRequest::getCmd('view','coupon');
		$vLayout 	= JRequest::getCmd('layout', 'form');
		$mName		= 'coupon';
		// Get/Create the view
		$view = &$this->getView( $vName, $vType);
		// Get/Create the model
		if ($model = &$this->getModel($mName)) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}
		// Set the layout
		$view->setLayout($vLayout);
		// Display the view
		$view->display();
	}

	function imgType() {
		$user = JFactory::getUser();
		$model = $this->getModel('wall');
		$url = 'index.php?option=com_yo_pixel&controller=wall&task=editAds&wall_id='.JRequest::getInt('wall_id', 0).'&cid[]='.JRequest::getInt('ads_id', 0);
		if ( $model->imgType() ){
			$msg =  'Upload image successful!';
		} else {
			$msg = 'File not supported!';
		}
		$this->setRedirect( $url, $msg);
	}

	function storeAds() {
		$model = $this->getModel('wall');
		if ( $model->AdsValidation() ) {
			if ( $model->storeAds() ) {
				$msg = JText::_('SAVE_ADS_SUCCESS');
			} else {
				$msg = JText::_('SAVE_ADS_ERROR');
			}
			$this->setRedirect('index.php?option=com_yo_pixel&controller=wall&task=detail&wall_id='.JRequest::getInt('wall_id', 0), $msg);
		} else {
			$this->editAds();
		}
		return ;
	}

	function cancel() {
		if ( JRequest::getInt('ads_id', 0 ) == 0) {
			$this->setRedirect('index.php?option=com_yo_pixel', 'Cancel');
		} else {
			$model = $this->getModel('wall');
			$model->deleteSession();//delete file has just upload but cancel called
			$this->setRedirect('index.php?option=com_yo_pixel&controller=wall&task=detail&wall_id='.JRequest::getInt('wall_id', 0), 'Cancel');
		}
		return ;
	}
	function editpaypalconfig(){
		JRequest::setVar('view','paypalconfig');
		JRequest::setVar('layout','form');
		JRequest::setVar('hidemainmenu',0);
		parent::display();
	}


	function canceleditconfig(){
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_yo_pixel&controller=wall&task=detailpaypalconfig', $msg );
	}

	function canceleditconfiguration(){
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_yo_pixel&controller=wall&task=detailconfigurations', $msg );
	}
	function cancelCoupon(){
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect('index.php?option=com_yo_pixel&controller=wall&task=coupon',$msg);
	}

	function saveconfig(){
		$model = $this->getModel('paypalconfig');

		if ($model->store($post)) {
			$msg = JText::_( 'Save Completed' );
		} else {
			$msg = JText::_( 'Error Saving' );
		}
		$link = 'index.php?option=com_yo_pixel&controller=wall&task=detailpaypalconfig';
		$this->setRedirect($link, $msg);
	}

	function storeConfig() {
		$model = $this->getModel('paypalconfig');

		if ( $model->storeConfig() ) {
			$msg = JText::_('SAVE_CONFIG_SUCCESS');
		} else {
			$msg = JText::_('SAVE_CONFIG_ERROR');
		}
		$this->setRedirect('index.php?option=com_yo_pixel',$msg);

		return ;
	}
	function storeConfiguration() {
		$model = $this->getModel('configuration');

		if ( $model->storeConfiguration() ) {
			$msg = JText::_('SAVE_CONFIGURATION_SUCCESS');
		} else {
			$msg = JText::_('SAVE_CONFIGURATION_ERROR');
		}
		$this->setRedirect('index.php?option=com_yo_pixel',$msg);

		return ;
	}

	function storeCoupon() {
		$model = $this->getModel('coupon');

		if ( $model->storeCoupon() ) {
			$msg = JText::_('SAVE_COUPON_SUCCESS');
		} else {
			$msg = JText::_('SAVE_COUPON_ERROR');
		}
		$this->setRedirect('index.php?option=com_yo_pixel&controller=wall&task=coupon',$msg);

		return ;
	}
	function removeCoupon(){
		$model = $this->getModel('coupons');
		if(!$model->delete()) {
			$msg = JText::_( 'Error: One or More Coupon Could not be Deleted' );
		} else {
			$msg = JText::_( 'Delete Completed' );
		}

		$this->setRedirect('index.php?option=com_yo_pixel&controller=wall&task=coupon',$msg);
	}


}

?>