<?php
/**
 * Changeconfig Model for Yo_Pixel Component
 * 
 * @package    Joomla.Tutorials
 * @subpackage Components
 * @link http://Econtentsite.com
 * @license		GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

/**
 * Managers Model
 */

class YO_PixelModelConfiguration extends JModel {

	var $_data;

	function __construct(){
		global $mainframe,$option;
		parent::__construct();

		$state				= $mainframe->getUserStateFromRequest( $option.'.eshowcasetip.state','state',-1,'string' );
		
		$this->setState('state',$state);
		
		$array = JRequest::getVar('cid',  0, '', 'array');

		$this->setId((int)$array[0]);
	}

	function setId($id)	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

		function _buildQuery()
		{
		// Get the WHERE and ORDER BY clauses for the query
			$query = ' SELECT * '
					. ' FROM #__yo_configuration '			;
					
			return $query;			
		}				

		/**
		 * Method to get a student
		 * @return object with data
		 */
	function getData()
	{
		// Load the data
			if (empty( $this->_data )) {
				$query = ' SELECT * FROM #__yo_configuration'.
						'  LIMIT 0,1';
				$this->_db->setQuery( $query );
				$this->_data = $this->_db->loadObjectList();
				}
			if (!$this->_data) {
				$this->_data = new stdClass();
				$this->_data->id = 0;
			}
				return $this->_data;
	}
	
	function storeConfiguration(){

		$db = JFactory::getDBO();
		$query = 'UPDATE #__yo_configuration SET termid=\''.JRequest::getString('termid').'\',unitprice=\''.JRequest::getString('unitprice').'\',price=\''.JRequest::getString('price').'\',max=\''.JRequest::getString('max').'\',
		 term=\''.JRequest::getString('term').'\',
					uploadby=\''.JRequest::getString('uploadby').'\'
				  WHERE id='.JRequest::getInt('id');
		$db->setQuery($query);
		$db->query();
		return true;
	}
	function &getUrlParams()
	{
		// Get the state parameters
		$item	= new stdClass();
		$item->linkparts['option']	= 'com_content';
		$item->linkparts['view']	= 'article';
		if($this->_article_id > 0)
		$item->linkparts['id']	= $this->_article_id;
		$params	= new JParameter('');
		if ($state =& $this->_getStateXML())
		{
			if (is_a($state, 'JSimpleXMLElement'))
			{
				$sp =& $state->getElementByPath('url');
				$params->setXML($sp);
				if (isset($item->linkparts) && is_array($item->linkparts)) {
					$params->loadArray($item->linkparts);
				}
			}
		}
//		var_dump($params); die();
		return $params;
	}

	function &_getStateXML()
	{
		static $xml;

		if (isset($xml)) {
			return $xml;
		}
		$xml = null;
		$xmlpath = null;

		$item	= new stdClass();
		$item->linkparts['option']	= 'com_content';
		$item->linkparts['view']	= 'article';

		$layout = 'default';

		$lpath = JPATH_ROOT.DS.'components'.DS.$item->linkparts['option'].DS.'views'.DS.$item->linkparts['view'].DS.'tmpl'.DS.$layout.'.xml';
		$vpath = JPATH_ROOT.DS.'components'.DS.$item->linkparts['option'].DS.'views'.DS.$item->linkparts['view'].DS.'metadata.xml';
		if (file_exists($lpath)) {
			$xmlpath = $lpath;
		} elseif (file_exists($vpath)) {
			$xmlpath = $vpath;
		}

		if (!$xmlpath && isset($item->linkparts['option'])) {
			$xmlpath = JPATH_ROOT.DS.'components'.DS.$item->linkparts['option'].DS.'metadata.xml';
			if(!file_exists($xmlpath)) {
				$xmlpath = JApplicationHelper::getPath('com_xml', $item->linkparts['option']);
			}
		}

		if (file_exists($xmlpath))
		{
			$xml =& JFactory::getXMLParser('Simple');

			if ($xml->loadFile($xmlpath)) {
				$this->_xml = &$xml;
				$document =& $xml->document;
				//				var_dump($document); die();

				/*
				* HANDLE NO OPTION CASE
				*/
				$menus =& $document->getElementByPath('menu');
				
				//				var_dump($menusF);die();
				if (is_a($menus, 'JSimpleXMLElement') && $menus->attributes('options') == 'none') {
					$xml =& $menus->getElementByPath('state');
					
				} else {
					$xml =& $document->getElementByPath('state');
					
				}
				// Handle error case... path doesn't exist
				if (!is_a($xml, 'JSimpleXMLElement')) {
					return $document;
				}

				/*
				* HANDLE A SWITCH IF IT EXISTS
				*/
				if ($switch = $xml->attributes('switch'))
				{
					$default = $xml->attributes('default');
					// Handle switch
					$switchVal = (isset($item->linkparts[$switch]))? $item->linkparts[$switch] : 'default';
					$found = false;

					foreach ($xml->children() as $child) {
						if ($child->name() == $switchVal) {
							$xml =& $child;
							$found = true;
							break;
						}
					}

					if (!$found) {
						foreach ($xml->children() as $child) {
							if ($child->name() == $default) {
								$xml =& $child;
								break;
							}
						}
					}
				}

				/*
				* HANDLE INCLUDED PARAMS
				*/
				$children = $xml->children();
				if (count($children) == 1)
				{
					if ($children[0]->name() == 'include') {
						$ret =& $this->_getIncludedParams($children[0]);
						if ($ret) {
							$xml =& $ret;
						}
					}
				}

				if ($switch = $xml->attributes('switch'))
				{
					$default = $xml->attributes('default');
					// Handle switch
					$switchVal = ($item->linkparts[$switch])? $item->linkparts[$switch] : 'default';
					$found = false;

					foreach ($xml->children() as $child) {
						if ($child->name() == $switchVal) {
							$xml =& $child;
							$found = true;
							break;
						}
					}

					if (!$found) {
						foreach ($xml->children() as $child) {
							if ($child->name() == $default) {
								$xml =& $child;
								break;
							}
						}
					}
				}
			}
		}
//		var_dump($xml); die();
		return $xml;
	}


}