<?php
/*------------------------------------------------------------------------

# draw_img.php - YO Pixel Controller

# ------------------------------------------------------------------------

# author    YOphp Site

# copyright Copyright (C) 2010 yophp.com. All Rights Reserved.

# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL

# Websites: http://www.yophp.com

# Technical Support:  Forum - http://forum.yophp.com

-------------------------------------------------------------------------*/
jimport('joomla.filesystem.folder');
require_once('cls_iresizer.php');

class drawImg
{
	function drawBorder( $sourcefile, $img ) {
		list($width, $height) = getimagesize($sourcefile);
		
		$img_resize = new ImageResizer();
		$img_resize->loadImage($sourcefile);
		$img_resize->resize( $width, $height );
		
		$im = $img_resize->getResult();
		
		//draw while border, size 1 pixel.
		$while = imagecolorallocate( $im, 0xFF, 0xFF, 0xFF );
		imagesetthickness( $im, 1 );
		
		//draw the rectangle to source file
		imagerectangle($im, 0, 0, $width, $height, $while);
		
		imagejpeg($im,  JPATH_COMPONENT.DS.'imgs'.DS.$img);
	}
	
	/**
	 * split the image to parts associate with cells has chosen.
	 *
	 * @param $source: source file
	 * @param $row: number row has chosen
	 * @param $col: number column has chosen
	 * @param $s: size of wall
	 * @param $numCol: number of wall columns
	 */
	function cut_Img( $source, $row, $col , $s , $numCol, $cells ) {
		
		$user = JFactory::getUser();		
		//get length of image
		list($width, $height ) = getimagesize($source);
		
		$img_resize = new ImageResizer();
		$img_resize->loadImage($source);
		$img_resize->resize($width, $height);
		$im = $img_resize->getResult();
		
		//destination of image
		$dest = imagecreatetruecolor($s, $s);
		
		$folder_path = JPATH_COMPONENT.DS.'imgs'.DS.'tmp_'.$user->username;
		if ( !JFolder::exists( JPATH_COMPONENT.DS.'imgs'.DS.'tmp_'.$user->username ) ) {
			JFolder::create( $folder_path );
		}
		
		//call offset to root
		$arr_cells = $this->offsetRoot( $cells, $numCol );		
		$xy = $this->posMin( $cells, $numCol );
		for ( $i = 0; $i < count($arr_cells); $i++ ) {
			$cells = preg_split('/\./', $arr_cells[$i]);
//			var_dump($cells);echo '<br>';
			$im_y = $cells[0];
			$im_x = $cells[1];
			$pos_y = $cells[0] + $xy[0];//column
			$pos_x = $cells[1] + $xy[1];//row
//			echo $pos_y.','.$pos_x.'<br>';
			
			$this->copyImg($folder_path, $dest, $im, $im_x, $im_y, $s, $pos_x, $pos_y );
		}
		
//		echo 'split successful!';
	}
	
	//copy image
	function copyImg( $folder, $dest, $im, $im_x, $im_y, $s , $pos_x, $pos_y ) {
		imagecopy( $dest, $im, 0, 0, $im_x*$s, $im_y*$s, ($im_x+1)*$s, ($im_y+1)*$s );
		imagejpeg($dest, $folder.DS.$pos_y.'.'.$pos_x.'.jpg');
	}
	
	//offset position of cells to root of axis
	//return array
	function offsetRoot( $listCells , $col ) {
		$arr_cells = preg_split('/,/', $listCells );
		
		for ($i=0; $i<count($arr_cells); $i++ ) {
			$arr_cell = $this->convertIntToCoordinate( $arr_cells[$i], $col);
			$arr_cells[$i] = $arr_cell[1].'.'.$arr_cell[0];
		}
		$arr_tmp = array();
		$xy = $this->posMin( $listCells , $col );
		for ($i = 0; $i < count($arr_cells); $i++ ) {
			$arr_cell = preg_split('/\./', $arr_cells[$i]);
			$arr_cell[0] = $arr_cell[0] - $xy[0] ;
			$arr_cell[1] = $arr_cell[1] - $xy[1] ;
			$arr_tmp[$i] = $arr_cell[0].'.'.$arr_cell[1];
		}
		
		return $arr_tmp;
	}
	
	//get min_x, min_y of current cells has chosen
	//$listcells: string of current cells has chosen
	function posMin( $listcells, $col ) {
		
		$arr_pos	=	array();
		$min_x = $min_y = 100000;
		$cells = preg_split('/,/', $listcells);
		for ($i=0; $i<count($cells); $i++ ) {
			$arr_cell = $this->convertIntToCoordinate( $cells[$i], $col);
			$cells[$i] = $arr_cell[1].'.'.$arr_cell[0];
		}
		foreach ($cells as $cell){
			$arr_xy = preg_split('/\./', $cell);
			if ($arr_xy[0] < $min_x) {
				$min_x = intval($arr_xy[0]);
			}
			if ($arr_xy[1] < $min_y) {
				$min_y = intval($arr_xy[1]);
			}
		}
		$arr_pos[0] = $min_x;
		$arr_pos[1] = $min_y;
		
		return $arr_pos;
	}
		
	function convertIntToCoordinate( $value , $cols ) {
		$cells = array();
		$cells[0] = $value % $cols;
		$cells[1] = floor( $value/$cols );
		return $cells;
	}
}

?>
