<?php
/*------------------------------------------------------------------------

# steptwo.php - YO Pixel Controller

# ------------------------------------------------------------------------

# author    YOphp Site

# copyright Copyright (C) 2010 yophp.com. All Rights Reserved.

# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL

# Websites: http://www.yophp.com

# Technical Support:  Forum - http://forum.yophp.com

-------------------------------------------------------------------------*/
defined('_JEXEC') or die('');

jimport('joomla.application.component.controller');

class YO_PixelControllerStepTwo extends JController
{
	function __construct( $default = array())
	{
		parent::__construct( $default );
	}

	function display() {
		global $mainframe;

		$this->validUser();
		$app=JFactory::getApplication();

		$vName 		= JRequest::getCmd('view', 'step2');
		$vLayout 	= JRequest::getCmd( 'layout', 'default' );
		$mName 		= 'wall';
		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();
		$px=JRequest::getString('yo_pixel_getcells');
		$m=preg_split('/,/',$px);
		$max=count($m);
		$md=$this->getModel('wall');
		$maxpixel=$md->getMax()->max;
		$wall_id	= JRequest::getInt('wall_id', 0);
		if ($maxpixel!=0&&$maxpixel!=null) {
			if ($max>(int)$maxpixel) {

				$app->Redirect('index.php?option=com_yo_pixel&view=step1&wall_id='.$wall_id,JText::_('Your choose more than the prescribed!'));

			}
		}
		// Get/Create the view
		$view = &$this->getView( $vName, $vType);
		// Get/Create the model
		if ($model = &$this->getModel($mName)) {
			//wall exist
			$wall_id	= JRequest::getInt('wall_id', 0);

			if ($wall_id == 0) {
				$app->Redirect('index.php', JText::_('PLS_SELECT_WALL'));
				return;
			} else {
				if ( !$model->wallValid($wall_id) ) {
					$app->Redirect('index.php', JText::_('WALL_NOT_FOUND'));
					return ;
				}
			}

			if ( !$model->CheckSsubmit($wall_id) ) {
				$app->Redirect('index.php', '');
				return ;
			}

			$listcells 		= JRequest::getVar('yo_pixel_getcells');
			if ($model->validation($listcells)) {
				$session 	= JFactory::getSession();
				$session->set('yo_pixel_cells', $listcells);
			} else {
				$app->Redirect(JRoute::_('index.php?option=com_yo_pixel&view=step1&wall_id='.$wall_id, false), JText::_('CELLS_POSTED_ERROR'));
			}

			// Push the model into the view (as default)
			$view->setModel($model, true);
		}
		// Set the layout
		$view->setLayout($vLayout);

		// Display the view
		$view->display();
	}

	function imgtype() {
		global $mainframe;

		$this->validUser();
		$app=JFactory::getApplication();
		$user 		= JFactory::getUser();
		$session 	= &JFactory::getSession();
		$wall_id	= $session->get('yo_pixel_id');
		$tmp_img	= $session->get('yo_pixel_tmp_img');
		$model 		= $this->getModel('wall');

		$session 	= JFactory::getSession();
		$action		= JRequest::getString('action');
		$ads_id		= JRequest::getInt('ads_id', 0);
		$cells		= $session->get('yo_pixel_cells');

		if (empty($cells) && empty($action)) {
			$app->Redirect(JRoute::_('index.php?option=com_yo_pixel&view=step1&wall_id='.$wall_id, false), JText::_('CELLS_NOT_FOUND'));
		}

		$url = 'index.php?option=com_yo_pixel&view=';
		if ( $model->imgType($wall_id, $cells, $tmp_img, $action, $ads_id) ){
			$msg =  JText::_('UPLOAD_IMG_SUCCESS');
			if($action == 'update') {
				$url .= 'editads&wall_id='.$wall_id.'&ads_id='.$ads_id;
				$this->setRedirect(JRoute::_($url, false), $msg);
			} else {
				$this->setRedirect(JRoute::_($url.'step2&wall_id='.$wall_id, false), $msg);
			}
		} else {
			$this->setRedirect(JRoute::_($url.'step2&wall_id='.$wall_id, false), JText::_('FILE_NOT_SUPPOST'));
		}
	}

	function validUser() {
		global $mainframe;

		$user = JFactory::getUser();
		//		if (empty($user->id)) {
		//			$mainframe->Redirect(JRoute::_('index.php?option=com_user&view=login'), JText::_('LOGIN_MESSAGE'));
		//		}
	}
}
?>