<?php
/*------------------------------------------------------------------------

# wall.php - YO Pixel Controller

# ------------------------------------------------------------------------

# author    YOphp Site

# copyright Copyright (C) 2010 yophp.com. All Rights Reserved.

# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL

# Websites: http://www.yophp.com

# Technical Support:  Forum - http://forum.yophp.com

-------------------------------------------------------------------------*/
defined('_JEXEC') or die();

jimport('joomla.application.component.model');

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

class YO_PixelModelWall extends JModel
{
	var $_wall_id	= null;
	var $_data;
	var $_data1;
	function __construct() {
		global  $mainframe,$option;
		parent::__construct();
		$app=JFactory::getApplication();


		$limit				= $app->getUserStateFromRequest($option.'.com_yo_pixel.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart			= $app->getUserStateFromRequest($option.'.com_yo_pixel.limitstart', 'limitstart', 0, 'int');
		$filter_unit 	=$app->getUserStateFromRequest($option.'com_yo_pixel.filter_status','filter_unit','','string');

		$this->setState('limit',$limit);
		$this->setState('limitstart',$limitstart);
		$this->setState('filter_unit',$filter_unit);
	}

	/**
	 * Check wall's id in database has existed
	 *
	 * @param $wall_id: wall's id
	 * @return bool
	 */
	function wallValid($wall_id) {
		$db 	= JFactory::getDBO();
		$query 	= ' SELECT '.$db->nameQuote('name').' FROM '.$db->nameQuote('#__yo_pixel')
		. ' WHERE '.$db->nameQuote('id').' = '.$db->Quote($wall_id);
		$db->setQuery($query);
		$result	= $db->loadResult();

		if (!empty($result)) {
			$this->_wall_id	= $wall_id;
			return true;
		}
		return false;
	}

	function CheckSsubmit($wall_id) {
		$db 	= JFactory::getDBO();
		$query 	= ' SELECT '.$db->nameQuote('ssubmit').' FROM '.$db->nameQuote('#__yo_pixel')
		. ' WHERE '.$db->nameQuote('id').' = '.$db->Quote($wall_id);
		$db->setQuery( $query );
		$ssubmit = $db->loadResult();

		if (!empty($ssubmit) && $ssubmit == 1)
		return true;

		return false;
	}

	/**
	 * Remove temparory image after upload
	 *
	 * @param $tmp_img: image will be removed
	 * @return none
	 */
	function removeTmpImg($tmp_img) {

		$session 	= JFactory::getSession();
		$session->set($tmp_img, '');
		$user 		= JFactory::getUser();

		$path 		= JPATH_COMPONENT.DS.'imgs';
		//delete tmp forder if exist
		if (JFolder::exists($path)){
			$files = JFolder::files( $path, '.', false, true, array());
			if (JFolder::exists( $path.DS.'tmp_'.$user->username))
			JFolder::delete( $path.DS.'tmp_'.$user->username);

			for ($i = 0; $i < count($files); $i++) {
				if ( $files[$i] == $path.DS.$tmp_img )
				JFile::delete($files[$i]);
			}
		}
	}

	//load all cells has chosen with wall
	function getCells() {
		$db 	= JFactory::getDBO();
		$query 	= ' SELECT a.cell_id, b.status FROM '.$db->nameQuote('#__yo_ads_cells').' AS a '
		. ' INNER JOIN '.$db->nameQuote('#__yo_ads').' AS b ON b.id = a.ads_id '
		. ' WHERE b.wall_id = '.$db->Quote($this->_wall_id);
		$db 	= JFactory::getDBO();

		$db->setQuery($query);
		return $db->loadObjectList();
	}

	/**
	 * Get parameter of wall
	 *
	 * @param $wall_id: wall's id
	 * @return dimention of wall: size, width, height
	 */
	function getParams() {
		$db 	= JFactory::getDBO();
		$query 	= ' SELECT * FROM '.$db->nameQuote('#__yo_pixel')
		. ' WHERE '.$db->nameQuote('id').' = '.$db->Quote($this->_wall_id);
		$db->setQuery($query);

		return  $db->loadObject();
	}

	/**
	 * Get image of user on the wall
	 *
	 * @param $wall_id wall has ads user on it
	 * @return List cells and ads_id contains image which has current user
	 */
	function getUserImg() {
		$user 	= JFactory::getUser();
		$db 	= JFactory::getDBO();
		$query 	= ' SELECT a.cell_id, a.ads_id FROM '.$db->nameQuote('#__yo_ads_cells').' AS a '
		. ' INNER JOIN '.$db->nameQuote('#__yo_ads').' AS b ON a.ads_id = b.id '
		. ' WHERE b.user_id = '.$db->Quote($user->id).' AND b.wall_id = '.$db->Quote($this->_wall_id);
		$db->setQuery($query);

		return $db->loadObjectList();
	}

	function validation($listcells) {
		if (empty($listcells)) {
			return false;
		}

		$valid = true;
		//check cells valid again
		$cells	=	split(',', $listcells);

		for ($i=0; $i<count($cells) - 1; $i++ ) {
			$currentCell = $cells[$i];
			unset ( $cells[$i] );
			foreach ( $cells as $cell ) {
				if ( $currentCell == $cell ) {
					$valid = false;
					break;
				}
			}
			if ( !$valid ) {
				break;
			}
		}

		return $valid;
	}

	//valid type of image user can posted.
	function imgType($wall_id, $cells, $tmp_img, $action, $ads_id) {
		$session 	= &JFactory::getSession();

		require_once(JPATH_COMPONENT.DS.'helpers'.DS.'cls_iresizer.php');

		if ($_FILES['upload_img']['type'] == 'image/jpeg' || $_FILES['upload_img']['type'] == 'image/png' || $_FILES['upload_img']['type'] == 'image/pjpeg' || $_FILES['upload_img']['type'] == 'image/gif')
		{
			$files 	= JFolder::files(JPATH_COMPONENT.DS.'imgs', '.', false, true, array());
			for ($i = 0; $i < count($files); $i++) {
				if ($files[$i] == JPATH_COMPONENT.DS.'imgs'.DS.$tmp_img) {
					JFile::delete($files[$i]);
				}
			}

			$user		= JFactory::getUser();
			$img_url 	= JPATH_COMPONENT.DS.'imgs'.DS.$user->username.'_'.$_FILES['upload_img']['name'];

			//save file to server
			JFile::upload($_FILES['upload_img']['tmp_name'], $img_url);
			//set session to image name
			$session->set('yo_pixel_tmp_img', $user->username.'_'.$_FILES['upload_img']['name']);

			//get size of new image
			if ($action == 'update') {
				$arr_cell 	= $this->CellsOfAds($ads_id, $wall_id);
				$arr_xy 	= $this->getsize( $wall_id, $arr_cell );
			} else {
				$arr_xy 	= $this->getsize( $wall_id,  $cells);
			}

			//resize image
			$imageResizer 	= new ImageResizer();
			$imageResizer->loadImage($img_url);
			$imageResizer->resize($arr_xy[1], $arr_xy[0]);
			$resize_img 	= $imageResizer->getResult();

			imagepng($resize_img, $img_url);

			return true;
		}

		return false;
	}

	/**
	 * get new size of image
	 *
	 * @return array: width, height
	 */
	function getsize($wall_id, $cells ) {

		$arr_pos	=	array();
		//get size of wall
		$db = JFactory::getDBO();
		$query = 'SELECT * FROM #__yo_pixel WHERE id = '.$wall_id;
		$db->setQuery($query);
		$dimension = $db->loadObject();

		$min_x = $min_y = 1000000000;
		$max_x = $max_y = 0;

		$cells = preg_split('/,/', $cells);

		for ($i=0; $i<count($cells); $i++ ) {
			//			echo $cells[$i].'<br>';
			$arr_cell = $this->convertIntToCoordinate( $cells[$i], $dimension->cols);
			$cells[$i] = $arr_cell[1].'.'.$arr_cell[0];
		}
		foreach ($cells as $cell){

			$arr_xy = preg_split('/\./', $cell);
			if ($arr_xy[0] < $min_x) {
				$min_x = intval($arr_xy[0]);
			}
			if ($arr_xy[0] > $max_x) {
				$max_x = intval($arr_xy[0]);
			}

			if ($arr_xy[1] < $min_y) {
				$min_y = intval($arr_xy[1]);
			}
			if ($arr_xy[1] > $max_y) {
				$max_y = intval($arr_xy[1]);
			}
		}

		$arr_pos[0] = ($max_x - $min_x + 1)*$dimension->size;//return number of column
		$arr_pos[1] = ($max_y - $min_y + 1)*$dimension->size;//return number of row

		return $arr_pos;
	}

	/**
	 * convert int value to co-ordinate
	 *
	 * @param $value: value will be converted
	 * @param $cols: columns number of wall
	 * @return array
	 */
	function convertIntToCoordinate( $value , $cols ) {
		$cells = array();
		$cells[0] = $value % $cols;
		$cells[1] = floor( $value/$cols );
		return $cells;
	}
	function getTerm(){
		$db=JFactory::getDBO();
		$query='SELECT #__content.id,#__content.catid,#__content.title FROM #__content INNER JOIN #__yo_configuration
		ON #__content.id=#__yo_configuration.termid';
		$db->setQuery($query);
		return $db->loadObjectList();
	}

	function getPrice(){
		$db = JFactory::getDBO();
		$query	='SELECT * FROM #__yo_configuration LIMIT 0,1';
		$db->setQuery($query);
		return  $db->loadObjectList();

	}


	/**
	 * get info of ads with current user logged
	 * @param $ads_id Id's ads
	 * @return Info of ads
	 */
	function AdsOfWall( $ads_id ) {
		$user = JFactory::getUser();
		$db = JFactory::getDBO();
		$query = 'SELECT * FROM #__yo_ads WHERE id='.$ads_id;
		$db->setQuery($query);

		return $db->loadObject();
	}

	/**
	 * get cells with id's ads
	 * @return list cells
	 */
	function CellsOfAds( $ads_id , $wall_id ) {

		$user 	= JFactory::getUser();
		$db 	= JFactory::getDBO();
		$query 	= ' SELECT cell_id FROM #__yo_ads_cells AS a INNER JOIN #__yo_ads AS b
					ON a.ads_id=b.id
				  	WHERE b.user_id='.$user->id.' AND b.wall_id='.$wall_id.' AND a.ads_id='.$ads_id;
		$db->setQuery($query);

		$arr_cell = '';
		$cells = $db->loadObjectList();
		for ( $i=0; $i < count( $cells ); $i++ ) {
			if ( $i == count( $cells ) - 1 ) {
				$arr_cell .= $cells[$i]->cell_id;
			} else {
				$arr_cell .= $cells[$i]->cell_id.',';
			}
		}
		return $arr_cell;
	}

	function store($wall_id, $cells) {

		//initialize expire day of user image posted
		$arr_expire = array('expire_date'=>'0000-00-00');
		$data = JRequest::get('post');
		$data = array_merge($arr_expire, $data);

		if(empty($data['name'])) return false;
		if(empty($data['info'])) return false;
		if(empty($data['url'])) return false;
		if(empty($data['address'])) return false;
		if(empty($data['phone'])) return false;
		if(empty($data['email'])) return false;

		$user = JFactory::getUser();
		//insert new ads
		$db = JFactory::getDBO();
		$query = ' INSERT INTO '.$db->nameQuote('#__yo_ads')
		.' VALUES("", '.$db->Quote($wall_id).', '
		. $db->Quote($user->id).', '
		. $db->Quote($data['name']).', '
		. $db->Quote($data['info']).', '
		. $db->Quote($data['url']).','
		. $db->Quote($data['pixel']).','
		. $db->Quote($data['price']).',"",'
		. $db->Quote($data['address']).','
		. $db->Quote($data['phone']).', '
		. $db->Quote($data['timeorder']).',"", '
		. $db->Quote($data['email']).', '
		. $db->Quote($data['publishup']).', "", "", '
		. $db->Quote($data['expire_date']).', '
		. $db->Quote('pending').')';
		//		var_dump($data); die();
		$db->setQuery($query);
		//		var_dump($query); die();
		if (!$db->query()) {
			return false;
		}

		//get id generated from insert oparation above
		$new_id = $db->insertid();

		//insert cells has chosen to ads_cells table
		$arr_cells = preg_split('/,/', $cells);

		foreach ( $arr_cells as $cell ) {
			//check cell existed
			$query = ' SELECT * FROM #__yo_ads_cells AS a INNER JOIN #__yo_ads AS b
						ON a.ads_id=b.id
							INNER JOIN #__yo_pixel AS c
							ON b.wall_id=c.id
					 	WHERE cell_id='.$cell.' AND c.id='.$wall_id;
			$db->setQuery($query);
			if ( count($db->loadObjectList()) == 0 ) { //not exist
				$query = 'INSERT INTO #__yo_ads_cells VALUES ("", '.$new_id.', '.$cell.')';
				$db->setQuery($query);
				//				var_dump($query); die();
				if (!$db->query()) {
					//delete info of this ads
					$query = 'DELETE FROM #__yo_ads WHERE id = '.$new_id;
					$db->setQuery($query);
					$db->query();

					return false;
				}

			}
		}
		//save image
		$this->imageAction($wall_id);
		return true;
	}
	function editads($wall_id, $tmp_img, $ads_id) {
		require_once(JPATH_COMPONENT.DS.'helpers'.DS.'draw_img.php');

		//get cells
		$cells 	= $this->CellsOfAds($ads_id, $wall_id);
		$arr_xy = $this->getsize($wall_id, $cells);

		//get size of wall
		$db 	= JFactory::getDBO();
		$query 	= ' SELECT * FROM '.$db->nameQuote('#__yo_pixel')
		. ' WHERE '.$db->nameQuote('id').' = '.$db->Quote($wall_id);
		$db->setQuery($query);

		$dimension	= $db->loadObject();

		if (!empty($tmp_img))
		{
			$draw_img = new drawImg();
			if ( JFile::exists(JPATH_COMPONENT.DS.'imgs'.DS.$tmp_img )) {
				//draw border image
				$draw_img->drawBorder(JPATH_COMPONENT.DS.'imgs'.DS.$tmp_img, $tmp_img );
				//split this image to parts image is smaller.
				$draw_img->cut_Img(JPATH_COMPONENT.DS.'imgs'.DS.$tmp_img, $arr_xy[0]/$dimension->size, $arr_xy[1]/$dimension->size, $dimension->size, $dimension->cols, $cells );
			}
			//save image
			$this->imageAction($wall_id);
		}

		//update info
		$name	= JRequest::getString('name');
		$url	= JRequest::getString('url');
		$info	= JRequest::getString('info');
		$ads_id	= JRequest::getInt('ads_id');
		$timeorder=JRequest::getString('timeorder');

		$query=' SELECT * FROM #__yo_configuration LIMIT 0,1';
		$db->setQuery($query);
		$data=$db->loadObject();
		$p=$data->price;
		$newamount=($p*$timeorder);
		$query 	= ' UPDATE '.$db->nameQuote('#__yo_ads').' SET '
		. $db->nameQuote('newtimeorder').' = '.$db->Quote($timeorder).','
		. $db->nameQuote('newprice').' = '.$db->Quote($newamount)
		. ' WHERE '.$db->nameQuote('id').' = '.$db->Quote($ads_id)
		;
		$db->setQuery($query);
		if ($db->query())
		return true;



		return false;
	}

	function imageAction($wall_id) {
		$user = JFactory::getUser();

		//move file to new folder
		if ( !JFolder::exists(JPATH_COMPONENT.DS.'imgs'.DS.'wall_'.$wall_id)) {
			JFolder::create(JPATH_COMPONENT.DS.'imgs'.DS.'wall_'.$wall_id);
		}
		$files = JFolder::files(JPATH_COMPONENT.DS.'imgs'.DS.'tmp_'.$user->username, '.', false, true, array());

		foreach ($files as $file) {
			//			$file_name = split(JPATH_COMPONENT.DS.'imgs'.DS.'tmp_'.$user->username.DS, $file);
			$file_name 	= JFile::getName($file);
			JFile::copy($file, JPATH_COMPONENT.DS.'imgs'.DS.'wall_'.$wall_id.DS.$file_name);
		}
		//delete tmp folder
		JFolder::delete(JPATH_COMPONENT.DS.'imgs'.DS.'tmp_'.$user->username);
	}

	function _buildQuery()
	{
		$query = ' SELECT * '
		. ' FROM #__yo_paypalconfig ';
		return $query;
	}

	//get config
	function getData()
	{
		if(empty($this->_data))
		{
			$query=$this->_buildQuery();
			$this->_data=$this->_getList($query,$this->getState('limitstart'),$this->getState('limit'));

		}
		return $this->_data;

	}

	//	function getInfo() {
	//		$db 	= JFactory::getDBO();
	//		$query 	= ' SELECT * FROM '.$db->nameQuote('#__yo_ads')
	//		. ' WHERE '.$db->nameQuote('status').' = '.$db->Quote('pending');
	//		$db->setQuery($query);
	//
	//		return  $db->loadObjectList();
	//	}
	function getInfo($id) {
		$db 	= JFactory::getDBO();
		$query = 'SELECT * FROM #__yo_ads WHERE id='.$id;
		$db->setQuery($query);
		return  $db->loadObject();
	}
	function deletePending(){

		$db = JFactory::getDBO();
		$query 	= ' DELETE FROM '.$db->nameQuote('#__yo_ads')
		. ' WHERE '.$db->nameQuote('status').' = '.$db->Quote('pending');
		$db->setQuery($query);
		$db->query();
		return true;

	}

	/**
		 * return list unitprice 
		 */
	function getNewinfo(){
		$db 	= JFactory::getDBO();
		$query 	= ' SELECT * FROM '.$db->nameQuote('#__yo_ads')
		. ' WHERE '.$db->nameQuote('id').' = (SELECT MAX(#__yo_ads.id) FROM #__yo_ads)';
		$db->setQuery($query);
		return  $db->loadObjectList();

	}
	function getTime(){
		$db 	= JFactory::getDBO();
		$query 	= ' SELECT * FROM '.$db->nameQuote('#__yo_ads');
		$db->setQuery($query);

		return  $db->loadObjectList();
	}
	function subtractDaysFromToday($time)
	{
		$today = mktime(0, 0, 0, date('m'), date('d'), date('Y'));
		$subtract = $today - (86400 * $time);

		//choice a date format here
		return date("Y-m-d", $subtract);
	}

	function getCoupon(){
		$db 	= JFactory::getDBO();
		$query 	= ' SELECT * FROM '.$db->nameQuote('#__yo_coupon')
		. ' WHERE '.$db->nameQuote('status').' = '.$db->Quote('published');;
		$db->setQuery($query)		;
		return  $db->loadObjectList();


	}
	function deleteCoupon(){
		$db=JFactory::getDBO();
		$query 	= ' DELETE FROM'.$db->nameQuote('#__yo_coupon')
		. ' WHERE '.$db->nameQuote('status').' = '.$db->Quote('unpublished');
		$db->setQuery($query);
		//		var_dump($query); die();
		$db->query();
		return true;

	}

	function unpublishedCoupon(){
		$db=JFactory::getDBO();
		$query 	= ' UPDATE '.$db->nameQuote('#__yo_coupon').' SET '
		. $db->nameQuote('status').' = '.$db->Quote('unpublished')
		. ' WHERE '.$db->nameQuote('status').' = '.$db->Quote('pending');
		$db->setQuery($query);
		$db->query();
		return true;
	}

	function publishCoupon(){
		$db=JFactory::getDBO();
		$query 	= ' UPDATE '.$db->nameQuote('#__yo_coupon').' SET '
		. $db->nameQuote('status').' = '.$db->Quote('published')
		. ' WHERE '.$db->nameQuote('status').' = '.$db->Quote('pending');
		$db->setQuery($query);
		$db->query();
		return true;
	}

	function getMax(){
		$db=JFactory::getDBO();
		$query='SELECT * FROM #__yo_configuration LIMIT 0,1';
		$db->setQuery($query);
		$db->query();
		return $db->loadObject();


	}
	function updateTime(){
		$db=JFactory::getDBO();
		$query 	= ' UPDATE '.$db->nameQuote('#__yo_ads').' SET '
		. $db->nameQuote('timeorder').' =  `#__yo_ads`.newtimeorder'
		. ' WHERE '.$db->nameQuote('newtimeorder').' != '.$db->Quote('0');
		$db->setQuery($query);
		//		var_dump($query); die();
		$db->query();
		return true;
	}
	function updateNewtime(){
		$db=JFactory::getDBO();
		$query 	= ' UPDATE '.$db->nameQuote('#__yo_ads').' SET '
		. $db->nameQuote('newtimeorder').' = '.$db->Quote('0');
		$db->setQuery($query);
		$db->query();
		return true;
	}
	function getNew() {
		$db 	= JFactory::getDBO();
		//		$query 	= ' SELECT * FROM '.$db->nameQuote('#__e_ads')
		//		. ' WHERE '.$db->nameQuote('status').' = '.$db->Quote('pending');
		$query 	= ' SELECT * FROM '.$db->nameQuote('#__yo_ads')
		. ' WHERE '.$db->nameQuote('id').' = (SELECT MAX(#__yo_ads.id) FROM #__yo_ads)';
		$db->setQuery($query);

		return  $db->loadObjectList();
	}
	
	function loadCells( $wall_id ) {
		$query = 'SELECT cell_id, b.status FROM #__yo_ads_cells AS a
					INNER JOIN #__yo_ads AS b ON b.id=a.ads_id 
				  WHERE b.wall_id='.$wall_id.' AND b.status=\'published\'';

		$db = JFactory::getDBO();

		$db->setQuery($query);
		return $db->loadObjectList();
	}




}
?>